unit opstring;

{ Workalike unit to TurboPower's Opstring }

interface

uses opinline;

type
  CompareType = (Less, Equal, Greater);

function CompString(const S1,S2:string):CompareType;
function CompUCString(const S1,S2:string):CompareType;

function HexB(b:byte):string;

function HexW(w:word):string;

function HexL(l:longint):string;

function Pad(s:string; len:byte):string;

function stUpcase(const S:String):String;

implementation

  uses
    Strings;


function CompString(const S1,S2:string):CompareType;
  var
    l, l1, l2 : byte;
    c : integer;
begin
  l1:=Length(S1);
  l2:=Length(S2);

  l:=l2;
  if l1<l2 then
    l:=l1;

  c:=StrLComp(@S1[1], @S2[1], l);
  if (c=0) and (l1<>l2) then
    if l1<l2 then
      CompString:=Less
    else
      CompString:=Greater
  else
    if c<0 then
      CompString:=Less
    else
      CompString:=CompareType(1+Ord(c>0));
end;

{$IFDEF Faster}

function CompUCString(const S1,S2:string):CompareType;
  var
    l, l1, l2 : byte;
    c : integer;
begin
  l1:=Length(S1);
  l2:=Length(S2);

  l:=l2;
  if l1<l2 then
    l:=l1;

  c:=StrLIComp(@S1[1], @S2[1], l);
  if (c=0) and (l1<>l2) then
    if l1<l2 then
      CompUCString:=Less
    else
      CompUCString:=Greater
  else
    if c<0 then
      CompUCString:=Less
    else
      CompUCString:=CompareType(1+Ord(c>0));
end;

{$ELSE}

function CompUCString(const S1,S2:string):CompareType;
var
  i : integer;
  len : integer;
  c1,c2 : char;
begin
  len := length(s1);
  if length(s2) < len then
    len := length(s2);
  for i:=1 to len do
  begin
    c1 := upcase(s1[i]);
    c2 := upcase(s2[i]);
    if c1 < c2 then
    begin
      CompUCString := Less;
      exit;
    end
    else if c1 > c2 then
    begin
      CompUCString := Greater;
      exit;
    end;
  end;
  if length(s1) < length(s2) then
    CompUCString := Less
  else if length(s1) = length(s2) then
    CompUCstring := Equal
  else
    CompUCstring := Greater;
end;

{$ENDIF}


function HexB;
const
  chars : array[0..$F] of char = '0123456789ABCDEF';
begin
  HexB := chars[b shr 4] + chars[b and $F];
end;

{$IFDEF Faster}
function HexW;
const
  HexChars : array[0..$F] of char = '0123456789ABCDEF';
begin
  HexW[0]:=Chr(4);
  HexW[1]:=HexChars[Hi(w) shr 4];
  HexW[2]:=HexChars[Hi(w) and $F];
  HexW[3]:=HexChars[Lo(w) shr 4];
  HexW[4]:=HexChars[Lo(w) and $F];
end;

{$ELSE}

function HexW;
begin
  HexW := HexB(Hi(w)) + HexB(Lo(w));
end;

{$ENDIF}

function HexL;
begin
  with LH(L) do
    HexL := HexW(H) + HexW(L);
end;

function Pad;
var
  i : integer;
begin
  if length(s) < len then
  begin
    for i := length(s)+1 to len do
      s[i] := ' ';
    s[0] := chr(len);
  end;
  Pad := s;
end;


function stUpcase;
  var
    i : Integer;
begin
  for i:=1 to Length(S) do
    stUpcase[i]:=Upcase(S[i]);
  stUpcase[0]:=Chr(Length(S));
end;

end.